/*
 * This file was generated automatically by xsubpp version 1.9508 from the
 * contents of FileList.xs. Do not edit this file, edit FileList.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "FileList.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#include "string.h"
#include "rsync.h"
#include <sys/stat.h>

typedef struct file_list *File__RsyncP__FileList;

/*
 * Pick an integer setting out of the hash ref opts.  If the argument
 * isn't a hash, or doesn't contain param, then returns def.
 */
static int getHashInt(SV *opts, char *param, int def)
{
    SV **vp;

    if ( !opts || !SvROK(opts)
               || SvTYPE(SvRV(opts)) != SVt_PVHV
               || !(vp = hv_fetch((HV*)SvRV(opts), param, strlen(param), 0))
               || !*vp ) {
        return def;
    }
    return SvIV(*vp);
}

/*
 * Pick an unsigned integer setting out of the hash ref opts.  If the
 * argument isn't a hash, or doesn't contain param, then returns def.
 */
static unsigned int getHashUInt(SV *opts, char *param, int def)
{
    SV **vp;

    if ( !opts || !SvROK(opts)
               || SvTYPE(SvRV(opts)) != SVt_PVHV
               || !(vp = hv_fetch((HV*)SvRV(opts), param, strlen(param), 0))
               || !*vp ) {
        return def;
    }
    return SvUV(*vp);
}

/*
 * Pick a string setting out of the hash ref opts.  If the argument
 * isn't a hash, or doesn't contain param, then returns def.
 */
static int getHashString(SV *opts, char *param, char *def,
                          char *result, int maxLen)
{
    SV **vp;
    char *str;
    unsigned int len;

    if ( !opts || !SvROK(opts)
               || SvTYPE(SvRV(opts)) != SVt_PVHV
               || !(vp = hv_fetch((HV*)SvRV(opts), param, strlen(param), 0))
               || !*vp ) {
        if ( !def )
            return -1;
        strcpy(result, def);
        return 0;
    } else {
        str = (char*)SvPV(*vp, len);
        if ( len >= maxLen ) {
            return -1;
        }
        memcpy(result, str, len);
        result[len] = '\0';
    }
    return 0;
}

/*
 * Pick a double setting out of the hash ref opts.  If the argument
 * isn't a hash, or doesn't contain param, then returns def.
 */
static double getHashDouble(SV *opts, char *param, double def)
{
    SV **vp;

    if ( !opts || !SvROK(opts)
               || SvTYPE(SvRV(opts)) != SVt_PVHV
               || !(vp = hv_fetch((HV*)SvRV(opts), param, strlen(param), 0))
               || !*vp ) {
        return def;
    }
    return SvNV(*vp);
}

/*
 * Check if a hash value defined.
 */
static int isHashDefined(SV *opts, char *param)
{
    SV **vp;

    if ( !opts || !SvROK(opts)
               || SvTYPE(SvRV(opts)) != SVt_PVHV
               || !(vp = hv_fetch((HV*)SvRV(opts), param, strlen(param), 0))
               || !*vp ) {
        return 0;
    }
    return 1;
}

#line 117 "FileList.c"

XS(XS_File__RsyncP__FileList_new); /* prototype to pass -Wmissing-prototypes */
XS(XS_File__RsyncP__FileList_new)
{
    dXSARGS;
    if (items < 0 || items > 2)
	Perl_croak(aTHX_ "Usage: File::RsyncP::FileList::new(packname = \"File::RsyncP::FileList\", opts = NULL)");
    {
	char *	packname;
	SV*	opts;
	File__RsyncP__FileList	RETVAL;

	if (items < 1)
	    packname = "File::RsyncP::FileList";
	else {
	    packname = (char *)SvPV_nolen(ST(0));
	}

	if (items < 2)
	    opts = NULL;
	else {
	    opts = ST(1);
	}
#line 116 "FileList.xs"
    {
        int preserve_hard_links = getHashInt(opts, "preserve_hard_links", 0);
        RETVAL = flist_new(1, "FileList new", preserve_hard_links);
        RETVAL->preserve_links   = getHashInt(opts, "preserve_links", 1);
        RETVAL->preserve_uid     = getHashInt(opts, "preserve_uid",   1);
        RETVAL->preserve_gid     = getHashInt(opts, "preserve_gid",   1);
        RETVAL->preserve_devices = getHashInt(opts, "preserve_devices", 0);
        RETVAL->always_checksum  = getHashInt(opts, "always_checksum", 0);
        RETVAL->preserve_hard_links = preserve_hard_links;
        RETVAL->protocol_version = getHashInt(opts, "protocol_version", 26);
        RETVAL->eol_nulls        = getHashInt(opts, "from0", 0);
    }
#line 154 "FileList.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "File::RsyncP::FileList", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_File__RsyncP__FileList_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_File__RsyncP__FileList_DESTROY)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: File::RsyncP::FileList::DESTROY(flist)");
    {
	File__RsyncP__FileList	flist;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    flist = INT2PTR(File__RsyncP__FileList,tmp);
	}
	else
	    Perl_croak(aTHX_ "flist is not a reference");
#line 135 "FileList.xs"
    {
        flist_free(flist);
    }
#line 181 "FileList.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_File__RsyncP__FileList_count); /* prototype to pass -Wmissing-prototypes */
XS(XS_File__RsyncP__FileList_count)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: File::RsyncP::FileList::count(flist)");
    {
	File__RsyncP__FileList	flist;
	unsigned int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "File::RsyncP::FileList")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    flist = INT2PTR(File__RsyncP__FileList,tmp);
	}
	else
	    Perl_croak(aTHX_ "flist is not of type File::RsyncP::FileList");
#line 143 "FileList.xs"
    {
        RETVAL = flist->count;
    }
#line 208 "FileList.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_File__RsyncP__FileList_fatalError); /* prototype to pass -Wmissing-prototypes */
XS(XS_File__RsyncP__FileList_fatalError)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: File::RsyncP::FileList::fatalError(flist)");
    {
	File__RsyncP__FileList	flist;
	unsigned int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "File::RsyncP::FileList")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    flist = INT2PTR(File__RsyncP__FileList,tmp);
	}
	else
	    Perl_croak(aTHX_ "flist is not of type File::RsyncP::FileList");
#line 153 "FileList.xs"
    {
        RETVAL = flist->fatalError;
    }
#line 236 "FileList.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_File__RsyncP__FileList_decodeDone); /* prototype to pass -Wmissing-prototypes */
XS(XS_File__RsyncP__FileList_decodeDone)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: File::RsyncP::FileList::decodeDone(flist)");
    {
	File__RsyncP__FileList	flist;
	unsigned int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "File::RsyncP::FileList")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    flist = INT2PTR(File__RsyncP__FileList,tmp);
	}
	else
	    Perl_croak(aTHX_ "flist is not of type File::RsyncP::FileList");
#line 163 "FileList.xs"
    {
        RETVAL = flist->decodeDone;
    }
#line 264 "FileList.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_File__RsyncP__FileList_decode); /* prototype to pass -Wmissing-prototypes */
XS(XS_File__RsyncP__FileList_decode)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: File::RsyncP::FileList::decode(flist, bytesSV)");
    {
#line 172 "FileList.xs"
	STRLEN nBytes;
#line 280 "FileList.c"
	File__RsyncP__FileList	flist;
	SV *	bytesSV = ST(1);
	unsigned char *	bytes = (unsigned char *)SvPV(bytesSV, nBytes);
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "File::RsyncP::FileList")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    flist = INT2PTR(File__RsyncP__FileList,tmp);
	}
	else
	    Perl_croak(aTHX_ "flist is not of type File::RsyncP::FileList");
#line 178 "FileList.xs"
    {
        RETVAL = flistDecodeBytes(flist, bytes, nBytes);
    }
#line 297 "FileList.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_File__RsyncP__FileList_get); /* prototype to pass -Wmissing-prototypes */
XS(XS_File__RsyncP__FileList_get)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: File::RsyncP::FileList::get(flist, index)");
    {
	File__RsyncP__FileList	flist;
	unsigned int	index = (unsigned int)SvUV(ST(1));
	SV *	RETVAL;

	if (sv_derived_from(ST(0), "File::RsyncP::FileList")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    flist = INT2PTR(File__RsyncP__FileList,tmp);
	}
	else
	    Perl_croak(aTHX_ "flist is not of type File::RsyncP::FileList");
#line 190 "FileList.xs"
    {
        HV *rh;
        struct file_struct *file;

        if ( index >= flist->count || !flist->files[index]->basename ) {
            XSRETURN_UNDEF; 
        }
        file = flist->files[index];
        rh = (HV *)sv_2mortal((SV *)newHV());
        if ( file->basename )
            hv_store(rh, "basename", 8, newSVpv(file->basename, 0), 0);
        if ( file->dirname )
            hv_store(rh, "dirname",  7, newSVpv(file->dirname, 0), 0);
        if ( S_ISLNK(file->mode) && file->u.link )
            hv_store(rh, "link",     4, newSVpv(file->u.link, 0), 0);
        if ( S_ISREG(file->mode) && file->u.sum )
            hv_store(rh, "sum",      3, newSVpv(file->u.sum, 0), 0);
        if ( IS_DEVICE(file->mode) ) {
            hv_store(rh, "rdev",        4, newSVnv((double)file->u.rdev), 0);
            hv_store(rh, "rdev_major", 10,
                            newSVnv((double)major(file->u.rdev)), 0);
            hv_store(rh, "rdev_minor", 10,
                            newSVnv((double)minor(file->u.rdev)), 0);
        }
        hv_store(rh, "name",    4, newSVpv(f_name(file), 0), 0);
        hv_store(rh, "uid",     3, newSVnv((double)((unsigned)file->uid)), 0);
        hv_store(rh, "gid",     3, newSVnv((double)((unsigned)file->gid)), 0);
        hv_store(rh, "mode",    4, newSVnv((double)((unsigned)file->mode)), 0);
        hv_store(rh, "mtime",   5,
			    newSVnv((double)((unsigned)file->modtime)), 0);
        hv_store(rh, "size",    4, newSVnv(file->length), 0);
        if ( flist->preserve_hard_links ) {
            if ( flist->link_idev_data_done ) {
                /*
                 * already run the hardlink linking code, so the link_u
                 * union has the links data in place
                 */
                if ( file->link_u.links ) {
                    /*
                     * return the name of the file this one is linked to
                     */
                    hv_store(rh, "hlink", 5, 
                        newSVpv(f_name(file->link_u.links->to), 0), 0);
                    if ( file == file->link_u.links->to ) {
                        /*
                         * Add flag if this is ourselves
                         */
                        hv_store(rh, "hlink_self", 10, newSVnv((double)1.0), 0);
                    }
                }
            } else {
                if ( file->link_u.idev ) {
                    hv_store(rh, "dev", 3, newSVnv(file->link_u.idev->dev), 0);
                    hv_store(rh, "inode", 5,
                        newSVnv(file->link_u.idev->inode), 0);
                }
            }
        }
        RETVAL = newRV((SV*)rh);
    }
#line 382 "FileList.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_File__RsyncP__FileList_flagGet); /* prototype to pass -Wmissing-prototypes */
XS(XS_File__RsyncP__FileList_flagGet)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: File::RsyncP::FileList::flagGet(flist, index)");
    {
	File__RsyncP__FileList	flist;
	unsigned int	index = (unsigned int)SvUV(ST(1));
	unsigned int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "File::RsyncP::FileList")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    flist = INT2PTR(File__RsyncP__FileList,tmp);
	}
	else
	    Perl_croak(aTHX_ "flist is not of type File::RsyncP::FileList");
#line 259 "FileList.xs"
    {
        if ( index >= flist->count ) {
            XSRETURN_UNDEF; 
        }
        RETVAL = flist->files[index]->flags & FLAG_USER_BOOL ? 1 : 0;
    }
#line 415 "FileList.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_File__RsyncP__FileList_flagSet); /* prototype to pass -Wmissing-prototypes */
XS(XS_File__RsyncP__FileList_flagSet)
{
    dXSARGS;
    if (items != 3)
	Perl_croak(aTHX_ "Usage: File::RsyncP::FileList::flagSet(flist, index, value)");
    {
	File__RsyncP__FileList	flist;
	unsigned int	index = (unsigned int)SvUV(ST(1));
	unsigned int	value = (unsigned int)SvUV(ST(2));

	if (sv_derived_from(ST(0), "File::RsyncP::FileList")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    flist = INT2PTR(File__RsyncP__FileList,tmp);
	}
	else
	    Perl_croak(aTHX_ "flist is not of type File::RsyncP::FileList");
#line 275 "FileList.xs"
    {
        if ( index < flist->count ) {
            if ( value ) {
                flist->files[index]->flags |= FLAG_USER_BOOL;
            } else {
                flist->files[index]->flags &= ~FLAG_USER_BOOL;
            }
        }
    }
#line 449 "FileList.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_File__RsyncP__FileList_clean); /* prototype to pass -Wmissing-prototypes */
XS(XS_File__RsyncP__FileList_clean)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: File::RsyncP::FileList::clean(flist)");
    {
	File__RsyncP__FileList	flist;

	if (sv_derived_from(ST(0), "File::RsyncP::FileList")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    flist = INT2PTR(File__RsyncP__FileList,tmp);
	}
	else
	    Perl_croak(aTHX_ "flist is not of type File::RsyncP::FileList");
#line 290 "FileList.xs"
    {
        clean_flist(flist, 0, 1);
    }
#line 474 "FileList.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_File__RsyncP__FileList_init_hard_links); /* prototype to pass -Wmissing-prototypes */
XS(XS_File__RsyncP__FileList_init_hard_links)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: File::RsyncP::FileList::init_hard_links(flist)");
    {
	File__RsyncP__FileList	flist;

	if (sv_derived_from(ST(0), "File::RsyncP::FileList")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    flist = INT2PTR(File__RsyncP__FileList,tmp);
	}
	else
	    Perl_croak(aTHX_ "flist is not of type File::RsyncP::FileList");
#line 299 "FileList.xs"
    {
        init_hard_links(flist);
    }
#line 499 "FileList.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_File__RsyncP__FileList_encode); /* prototype to pass -Wmissing-prototypes */
XS(XS_File__RsyncP__FileList_encode)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: File::RsyncP::FileList::encode(flist, data)");
    {
	File__RsyncP__FileList	flist;
	SV*	data = ST(1);

	if (sv_derived_from(ST(0), "File::RsyncP::FileList")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    flist = INT2PTR(File__RsyncP__FileList,tmp);
	}
	else
	    Perl_croak(aTHX_ "flist is not of type File::RsyncP::FileList");
#line 309 "FileList.xs"
    {
        struct file_struct *file;
        char sum[SUM_LENGTH];
        char thisname[MAXPATHLEN];
        char linkname[MAXPATHLEN];
        int alloc_len, basename_len, dirname_len, linkname_len, sum_len;
        char *basename, *dirname, *bp;
        unsigned short flags = 0;
        unsigned int mode = getHashUInt(data, "mode", 0);

        unsigned int file_struct_len;
        struct file_struct f_test;

        /* Figure out how big the file_struct is without trailing padding */
        file_struct_len = offsetof(struct file_struct, flags)
                        + sizeof f_test.flags;

        if (!flist || !flist->count)    /* Ignore lastdir when invalid. */
                flist->encode_lastdir_len = -1;

        if ( getHashString(data, "name", NULL, thisname, MAXPATHLEN-1) ) {
            printf("flist encode: empty or too long name\n");
            return;
        }
        clean_fname(thisname, 0);

        memset(sum, 0, SUM_LENGTH);

        if ( S_ISLNK(mode) && getHashString(data, "link", NULL, linkname,
                                            MAXPATHLEN-1) ) {
            printf("flist encode: link name is too long\n");
            return;
        }

        if ((basename = strrchr(thisname, '/')) != NULL) {
            dirname_len = ++basename - thisname; /* counts future '\0' */
            if (flist->encode_lastdir_len == dirname_len - 1
                    && strncmp(thisname, flist->encode_lastdir,
                                   flist->encode_lastdir_len) == 0) {
                dirname = flist->encode_lastdir;
                dirname_len = 0; /* indicates no copy is needed */
            } else
                dirname = thisname;
        } else {
            basename = thisname;
            dirname = NULL;
            dirname_len = 0;
        }
        basename_len = strlen(basename) + 1; /* count the '\0' */

        linkname_len = S_ISLNK(mode) ? strlen(linkname) + 1 : 0;

        sum_len = flist->always_checksum && S_ISREG(mode) ? MD4_SUM_LENGTH : 0;

        alloc_len = file_struct_len + dirname_len + basename_len
            + linkname_len + sum_len;
        if (flist) {
            bp = pool_alloc(flist->file_pool, alloc_len,
                "receive_file_entry");
        } else {
            if (!(bp = malloc(sizeof(char) * alloc_len))) {
                printf("out of memory: receive_file_entry");
                return;
            }
        }

        file = (struct file_struct *)bp;
        memset(bp, 0, file_struct_len);
        bp += file_struct_len;

        file->flags   = flags;
        file->modtime = getHashUInt(data, "mtime", 0);
        file->length  = getHashDouble(data, "size", 0.0);
        file->mode    = mode;
        file->uid     = getHashUInt(data, "uid", 0);
        file->gid     = getHashUInt(data, "gid", 0);

        if (flist->preserve_hard_links && flist->idev_pool) {
            if (flist->protocol_version < 28) {
                if (S_ISREG(mode))
                        file->link_u.idev = pool_talloc(
                            flist->idev_pool, struct idev, 1,
                            "inode_table");
            } else {
                if (!S_ISDIR(mode) && isHashDefined(data, "inode"))
                        file->link_u.idev = pool_talloc(
                            flist->idev_pool, struct idev, 1,
                            "inode_table");
            }
        }
        if (file->link_u.idev) {
            file->F_DEV = getHashDouble(data, "dev", 0.0);
            file->F_INODE = getHashDouble(data, "inode", 0.0);
        }

        if (dirname_len) {
            file->dirname = flist->encode_lastdir = bp;
            flist->encode_lastdir_len = dirname_len - 1;
            memcpy(bp, dirname, dirname_len - 1);
            bp += dirname_len;
            bp[-1] = '\0';
        } else if (dirname)
            file->dirname = dirname;

        file->basename = bp;
        memcpy(bp, basename, basename_len);
        bp += basename_len;

        if (flist->preserve_devices && IS_DEVICE(mode)) {
            if ( isHashDefined(data, "rdev_major") ) {
                file->u.rdev = makedev(getHashUInt(data, "rdev_major", 0),
                                       getHashUInt(data, "rdev_minor", 0));
            } else if ( isHashDefined(data, "rdev") ) {
                file->u.rdev = getHashUInt(data, "rdev", 0);
            } else {
                printf("File::RsyncP::FileList::encode: missing rdev on device file %s\n",
                                thisname);
                file->u.rdev = 0;
            }
        }

        if (linkname_len) {
            file->u.link = bp;
            memcpy(bp, linkname, linkname_len);
            bp += linkname_len;
        }

        if (sum_len) {
            file->u.sum = bp;
            /* TODO */
            memset(bp, 0, sum_len);
            /*bp += sum_len;*/
        }

        file->basedir = NULL;           /* TODO */

        flist_expand(flist);

        if (file->basename[0]) {
            flist->files[flist->count++] = file;
            send_file_entry(flist, file, 0 /* TODO base_flags */);
        }
    }
#line 665 "FileList.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_File__RsyncP__FileList_encodeData); /* prototype to pass -Wmissing-prototypes */
XS(XS_File__RsyncP__FileList_encodeData)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: File::RsyncP::FileList::encodeData(flist)");
    {
	File__RsyncP__FileList	flist;
	SV *	RETVAL;

	if (sv_derived_from(ST(0), "File::RsyncP::FileList")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    flist = INT2PTR(File__RsyncP__FileList,tmp);
	}
	else
	    Perl_croak(aTHX_ "flist is not of type File::RsyncP::FileList");
#line 458 "FileList.xs"
    {
        if ( !flist->outBuf || flist->outPosn == 0 ) {
            ST(0) = sv_2mortal(newSVpv("", 0));
        } else {
            ST(0) = sv_2mortal(newSVpv((char*)flist->outBuf, flist->outPosn));
            flist->outPosn = 0;
        }
    }
#line 696 "FileList.c"
    }
    XSRETURN(1);
}


XS(XS_File__RsyncP__FileList_exclude_check); /* prototype to pass -Wmissing-prototypes */
XS(XS_File__RsyncP__FileList_exclude_check)
{
    dXSARGS;
    if (items != 3)
	Perl_croak(aTHX_ "Usage: File::RsyncP::FileList::exclude_check(flist, pathSV, isDir)");
    {
#line 470 "FileList.xs"
	STRLEN pathLen;
#line 711 "FileList.c"
	File__RsyncP__FileList	flist;
	SV *	pathSV = ST(1);
	unsigned char *	path = (unsigned char *)SvPV(pathSV, pathLen);
	unsigned int	isDir = (unsigned int)SvUV(ST(2));
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "File::RsyncP::FileList")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    flist = INT2PTR(File__RsyncP__FileList,tmp);
	}
	else
	    Perl_croak(aTHX_ "flist is not of type File::RsyncP::FileList");
#line 477 "FileList.xs"
    {
        RETVAL = check_exclude(flist, (char*)path, isDir);
    }
#line 729 "FileList.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_File__RsyncP__FileList_exclude_add); /* prototype to pass -Wmissing-prototypes */
XS(XS_File__RsyncP__FileList_exclude_add)
{
    dXSARGS;
    if (items != 3)
	Perl_croak(aTHX_ "Usage: File::RsyncP::FileList::exclude_add(flist, patternSV, flags)");
    {
#line 486 "FileList.xs"
	STRLEN patternLen;
#line 745 "FileList.c"
	File__RsyncP__FileList	flist;
	SV *	patternSV = ST(1);
	unsigned char *	pattern = (unsigned char *)SvPV(patternSV, patternLen);
	unsigned int	flags = (unsigned int)SvUV(ST(2));

	if (sv_derived_from(ST(0), "File::RsyncP::FileList")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    flist = INT2PTR(File__RsyncP__FileList,tmp);
	}
	else
	    Perl_croak(aTHX_ "flist is not of type File::RsyncP::FileList");
#line 493 "FileList.xs"
    {
        add_exclude(flist, (char*)pattern, flags);
    }
#line 761 "FileList.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_File__RsyncP__FileList_exclude_add_file); /* prototype to pass -Wmissing-prototypes */
XS(XS_File__RsyncP__FileList_exclude_add_file)
{
    dXSARGS;
    if (items != 3)
	Perl_croak(aTHX_ "Usage: File::RsyncP::FileList::exclude_add_file(flist, fileNameSV, flags)");
    {
#line 500 "FileList.xs"
	STRLEN fileNameLen;
#line 776 "FileList.c"
	File__RsyncP__FileList	flist;
	SV *	fileNameSV = ST(1);
	unsigned char *	fileName = (unsigned char *)SvPV(fileNameSV, fileNameLen);
	unsigned int	flags = (unsigned int)SvUV(ST(2));

	if (sv_derived_from(ST(0), "File::RsyncP::FileList")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    flist = INT2PTR(File__RsyncP__FileList,tmp);
	}
	else
	    Perl_croak(aTHX_ "flist is not of type File::RsyncP::FileList");
#line 507 "FileList.xs"
    {
        add_exclude_file(flist, (char*)fileName, flags);
    }
#line 792 "FileList.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_File__RsyncP__FileList_exclude_cvs_add); /* prototype to pass -Wmissing-prototypes */
XS(XS_File__RsyncP__FileList_exclude_cvs_add)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: File::RsyncP::FileList::exclude_cvs_add(flist)");
    {
	File__RsyncP__FileList	flist;

	if (sv_derived_from(ST(0), "File::RsyncP::FileList")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    flist = INT2PTR(File__RsyncP__FileList,tmp);
	}
	else
	    Perl_croak(aTHX_ "flist is not of type File::RsyncP::FileList");
#line 516 "FileList.xs"
    {
        add_cvs_excludes(flist);
    }
#line 817 "FileList.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_File__RsyncP__FileList_exclude_list_send); /* prototype to pass -Wmissing-prototypes */
XS(XS_File__RsyncP__FileList_exclude_list_send)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: File::RsyncP::FileList::exclude_list_send(flist)");
    {
	File__RsyncP__FileList	flist;

	if (sv_derived_from(ST(0), "File::RsyncP::FileList")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    flist = INT2PTR(File__RsyncP__FileList,tmp);
	}
	else
	    Perl_croak(aTHX_ "flist is not of type File::RsyncP::FileList");
#line 525 "FileList.xs"
    {
        send_exclude_list(flist);
    }
#line 842 "FileList.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_File__RsyncP__FileList_exclude_list_receive); /* prototype to pass -Wmissing-prototypes */
XS(XS_File__RsyncP__FileList_exclude_list_receive)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: File::RsyncP::FileList::exclude_list_receive(flist)");
    {
	File__RsyncP__FileList	flist;

	if (sv_derived_from(ST(0), "File::RsyncP::FileList")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    flist = INT2PTR(File__RsyncP__FileList,tmp);
	}
	else
	    Perl_croak(aTHX_ "flist is not of type File::RsyncP::FileList");
#line 534 "FileList.xs"
    {
        recv_exclude_list(flist);
    }
#line 867 "FileList.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_File__RsyncP__FileList_exclude_list_clear); /* prototype to pass -Wmissing-prototypes */
XS(XS_File__RsyncP__FileList_exclude_list_clear)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: File::RsyncP::FileList::exclude_list_clear(flist)");
    {
	File__RsyncP__FileList	flist;

	if (sv_derived_from(ST(0), "File::RsyncP::FileList")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    flist = INT2PTR(File__RsyncP__FileList,tmp);
	}
	else
	    Perl_croak(aTHX_ "flist is not of type File::RsyncP::FileList");
#line 543 "FileList.xs"
    {
        clear_exclude_list(&flist->exclude_list);
    }
#line 892 "FileList.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_File__RsyncP__FileList_exclude_list_get); /* prototype to pass -Wmissing-prototypes */
XS(XS_File__RsyncP__FileList_exclude_list_get)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: File::RsyncP::FileList::exclude_list_get(flist)");
    {
	File__RsyncP__FileList	flist;
	SV *	RETVAL;

	if (sv_derived_from(ST(0), "File::RsyncP::FileList")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    flist = INT2PTR(File__RsyncP__FileList,tmp);
	}
	else
	    Perl_croak(aTHX_ "flist is not of type File::RsyncP::FileList");
#line 552 "FileList.xs"
        {
            AV *result;
            struct exclude_struct *ent;

            result = (AV *)sv_2mortal((SV *)newAV());

            for (ent = flist->exclude_list.head; ent; ent = ent->next) {
                HV *rh = (HV *)sv_2mortal((SV *)newHV());
                hv_store(rh, "pattern", 7,
                         newSVpvn(ent->pattern, strlen(ent->pattern)), 0);
                hv_store(rh, "flags", 5,
                         newSVnv((double)ent->match_flags), 0);
                av_push(result, newRV((SV *)rh));
            }
            RETVAL = newRV((SV *)result);
        }
#line 931 "FileList.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS(boot_File__RsyncP__FileList); /* prototype to pass -Wmissing-prototypes */
XS(boot_File__RsyncP__FileList)
{
    dXSARGS;
    char* file = __FILE__;

    XS_VERSION_BOOTCHECK ;

        newXS("File::RsyncP::FileList::new", XS_File__RsyncP__FileList_new, file);
        newXS("File::RsyncP::FileList::DESTROY", XS_File__RsyncP__FileList_DESTROY, file);
        newXS("File::RsyncP::FileList::count", XS_File__RsyncP__FileList_count, file);
        newXS("File::RsyncP::FileList::fatalError", XS_File__RsyncP__FileList_fatalError, file);
        newXS("File::RsyncP::FileList::decodeDone", XS_File__RsyncP__FileList_decodeDone, file);
        newXS("File::RsyncP::FileList::decode", XS_File__RsyncP__FileList_decode, file);
        newXS("File::RsyncP::FileList::get", XS_File__RsyncP__FileList_get, file);
        newXS("File::RsyncP::FileList::flagGet", XS_File__RsyncP__FileList_flagGet, file);
        newXS("File::RsyncP::FileList::flagSet", XS_File__RsyncP__FileList_flagSet, file);
        newXS("File::RsyncP::FileList::clean", XS_File__RsyncP__FileList_clean, file);
        newXS("File::RsyncP::FileList::init_hard_links", XS_File__RsyncP__FileList_init_hard_links, file);
        newXS("File::RsyncP::FileList::encode", XS_File__RsyncP__FileList_encode, file);
        newXS("File::RsyncP::FileList::encodeData", XS_File__RsyncP__FileList_encodeData, file);
        newXS("File::RsyncP::FileList::exclude_check", XS_File__RsyncP__FileList_exclude_check, file);
        newXS("File::RsyncP::FileList::exclude_add", XS_File__RsyncP__FileList_exclude_add, file);
        newXS("File::RsyncP::FileList::exclude_add_file", XS_File__RsyncP__FileList_exclude_add_file, file);
        newXS("File::RsyncP::FileList::exclude_cvs_add", XS_File__RsyncP__FileList_exclude_cvs_add, file);
        newXS("File::RsyncP::FileList::exclude_list_send", XS_File__RsyncP__FileList_exclude_list_send, file);
        newXS("File::RsyncP::FileList::exclude_list_receive", XS_File__RsyncP__FileList_exclude_list_receive, file);
        newXS("File::RsyncP::FileList::exclude_list_clear", XS_File__RsyncP__FileList_exclude_list_clear, file);
        newXS("File::RsyncP::FileList::exclude_list_get", XS_File__RsyncP__FileList_exclude_list_get, file);
    XSRETURN_YES;
}

